import * as React from 'react';
export interface ComponentProps {
    restore?: (element: HTMLElement, store?: any) => Promise<any> | any;
    store?: any;
    live: boolean;
    className?: string;
    style?: React.CSSProperties;
}
export interface WrapperProps {
    id: string;
    className?: string;
    style?: React.CSSProperties;
    live: boolean;
    dehydrate: (element: HTMLElement) => void;
}
export interface ComponentState {
    live: boolean;
    hydrated: boolean;
    state: any;
}
export declare class PrerenderedComponent extends React.Component<ComponentProps, ComponentState> {
    state: ComponentState;
    componentDidMount(): void;
    dehydrate: (el: HTMLElement) => void;
    render(): JSX.Element;
}
