"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var utils_1 = require("./utils");
exports.cacheControler = function (cache) {
    var counter = 0;
    var cachedValues = {};
    var cached = {};
    return {
        cache: cache,
        get: function (key) {
            return cachedValues[cached[key].key];
        },
        set: function (id, value) {
            var _a = cached[id], key = _a.key, ttl = _a.ttl;
            cache.set(key, value, ttl);
        },
        store: function (key, value) {
            cachedValues[key] = value;
            return this.assign(key, 0);
        },
        assign: function (key, ttl) {
            counter++;
            cached[counter] = { key: key, ttl: ttl };
            return counter;
        }
    };
};
var context = React.createContext({
    isServer: utils_1.isThisServer(),
});
exports.PrerenderedControler = function (_a) {
    var children = _a.children, props = __rest(_a, ["children"]);
    return (React.createElement(context.Provider, { value: __assign({ isServer: utils_1.isThisServer() }, props) }, children));
};
exports.PrerenderedControls = context.Consumer;
